=== debian/changelog ===
innoextract (1.8-1) unstable; urgency=medium

  * Move to new upstream version. Deprecating the last patch

 -- Lennart Weller <lhw@ring0.de>  Wed, 15 Jan 2020 16:30:07 +0100
