=== debian/control ===
Source: innoextract
Section: utils
Priority: optional
Maintainer: Lennart Weller <lhw@ring0.de>
Uploaders: Sebastian Reichel <sre@debian.org>
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/lhw-guest/innoextract
Vcs-git: https://salsa.debian.org/lhw-guest/innoextract.git
Homepage: http://constexpr.org/innoextract/
Build-Depends: cmake,
               debhelper (>= 12),
               debhelper-compat(= 12),
               dpkg-dev (>= 1.16.1~),
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libboost-date-time-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               liblzma-dev

Package: innoextract
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tool for extracting data from an Inno Setup installer
 Inno Setup is a tool to create installers for Microsoft Windows applications.
 Inno Extracts allows one to extract such installers under non-windows systems
 without running the actual installer using wine. Inno Extract currently
 supports installers created by Inno Setup 1.2.10 to 5.6.0.
