=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ \
	https://github.com/dscharrer/innoextract/releases .*?/(?:\d\S*)/innoextract-(\d\S*)\.tar\.gz
