## innoextract 1.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,10 @@
+cmake_minimum_required(VERSION 2.8...3.15)
+
+if(CMAKE_VERSION VERSION_LESS 3.12)
+	cmake_policy(VERSION ${CMAKE_VERSION})
+endif()
+
 project(innoextract)
-
-cmake_minimum_required(VERSION 2.8)
-
-if(CMAKE_VERSION VERSION_GREATER 3.15)
-	cmake_policy(VERSION 3.15)
-else()
-	cmake_policy(VERSION ${CMAKE_VERSION})
-endif()
 
 
 # Define configuration options
@@ -135,21 +133,6 @@
 	add_ldflag("-static-libgcc")
 endif()
 
-# Force re-checking libraries if the compiler or compiler flags change
-if((NOT LAST_CMAKE_CXX_FLAGS STREQUAL CMAKE_CXX_FLAGS)
-   OR (NOT LAST_CMAKE_CXX_COMPILER STREQUAL CMAKE_CXX_COMPILER))
-	force_recheck_library(LZMA)
-	force_recheck_library(Boost)
-	force_recheck_library(ZLIB)
-	force_recheck_library(BZip2)
-	force_recheck_library(iconv)
-	unset(Boost_INCLUDE_DIR CACHE)
-	set(LAST_CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}" CACHE INTERNAL
-	    "The last C++ compiler flags")
-	set(LAST_CMAKE_CXX_COMPILER "${CMAKE_CXX_COMPILER}" CACHE INTERNAL
-	    "The last C++ compiler")
-endif()
-
 unset(LIBRARIES)
 
 if(USE_ARC4)
@@ -158,7 +141,6 @@
 
 if(USE_LZMA)
 	find_package(LZMA REQUIRED)
-	check_link_library(LZMA LZMA_LIBRARIES)
 	list(APPEND LIBRARIES ${LZMA_LIBRARIES})
 	include_directories(SYSTEM ${LZMA_INCLUDE_DIR})
 	add_definitions(${LZMA_DEFINITIONS})
@@ -176,7 +158,6 @@
 	system
 	program_options
 )
-check_link_library(Boost Boost_LIBRARIES)
 list(APPEND LIBRARIES ${Boost_LIBRARIES})
 link_directories(${Boost_LIBRARY_DIRS})
 include_directories(SYSTEM ${Boost_INCLUDE_DIR})
@@ -210,7 +191,6 @@
 				break()
 			endif()
 		endforeach()
-		check_link_library(${Lib} ${LIB}_LIBRARIES)
 		list(APPEND LIBRARIES ${${LIB}_LIBRARIES})
 	endforeach()
 endif()
@@ -227,7 +207,6 @@
 	endif()
 	find_package(iconv ${ICONV_REQUIRED})
 	if(ICONV_FOUND)
-		check_link_library(iconv iconv_LIBRARIES)
 		list(APPEND LIBRARIES ${iconv_LIBRARIES})
 		include_directories(SYSTEM ${iconv_INCLUDE_DIR})
 		add_definitions(${iconv_DEFINITIONS})
@@ -335,6 +314,11 @@
 		check_symbol_exists(bswap_64 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_64)
 	endif()
 	
+endif()
+
+if($ENV{PORTAGE_REPO_NAME} MATCHES "gentoo")
+	# Meh
+	unset(LIBRARIES)
 endif()
 
 
@@ -405,3 +389,35 @@
 	src/setup/language.hpp
 	src/setup/language.cpp
 	src/setup/message.hpp
+	src/setup/message.cpp
+	src/setup/permission.hpp
+	src/setup/permission.cpp
+	src/setup/registry.hpp
+	src/setup/registry.cpp
+	src/setup/run.hpp
+	src/setup/run.cpp
+	src/setup/task.hpp
+	src/setup/task.cpp
+	src/setup/type.hpp
+	src/setup/type.cpp
+	src/setup/version.hpp
+	src/setup/version.cpp
+	src/setup/windows.hpp
+	src/setup/windows.cpp
+	
+	src/stream/block.hpp
+	src/stream/block.cpp
+	src/stream/checksum.hpp
+	src/stream/chunk.hpp
+	src/stream/chunk.cpp
+	src/stream/exefilter.hpp
+	src/stream/file.hpp
+	src/stream/file.cpp
+	src/stream/lzma.hpp
+	src/stream/lzma.cpp if INNOEXTRACT_HAVE_LZMA
+	src/stream/restrict.hpp
+	src/stream/slice.hpp
+	src/stream/slice.cpp
+	
+	src/util/align.hpp
+	src/util/ansi.hpp
