=== debian/changelog ===
innoextract (1.9-1) unstable; urgency=medium

  * Salvage package inside Games Team (Closes: #1116573)

 -- Alexandre Detiste <tchet@debian.org>  Thu, 23 Oct 2025 18:00:04 +0200

innoextract (1.9-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4 (Closes: #1113042)

 -- Alexandre Detiste <tchet@debian.org>  Sun, 28 Sep 2025 19:35:51 +0200

innoextract (1.9-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release. (Closes: #1018828)
  * debian/copyright: Update years.
  * debian/patches: Remove the last patch.
  * debian/watch: Update for the latest github changes.

 -- Anatoliy Gunya <csm.sub21@gmail.com>  Mon, 07 Nov 2022 19:08:30 +0300

innoextract (1.8-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Apply upstream patch to fix build with boost 1.71.
    (Closes: #949837)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 07 Jun 2020 22:00:19 +0200

innoextract (1.8-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Go back to debhelper-compat 11 to work around dwz issues on
    mipsel and mips64el. (see #956954) (Closes: #954259)

 -- Adrian Bunk <bunk@debian.org>  Sat, 02 May 2020 21:00:51 +0300
