=== debian/control ===
Source: innoextract
Section: utils
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Alexandre Detiste <tchet@debian.org>,
 Lennart Weller <lhw@ring0.de>,
Standards-Version: 4.7.2
Build-Depends:
 debhelper-compat(= 13),
 cmake,
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 liblzma-dev,
Vcs-Browser: https://salsa.debian.org/games-team/innoextract
Vcs-Git: https://salsa.debian.org/games-team/innoextract.git
Homepage: https://constexpr.org/innoextract/

Package: innoextract
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Tool for extracting data from an Inno Setup installer
 Inno Setup is a tool to create installers for Microsoft Windows applications.
 Inno Extracts allows one to extract such installers under non-windows systems
 without running the actual installer using wine. Inno Extract currently
 supports installers created by Inno Setup 1.2.10 to 5.6.0.
