=== debian/watch ===
Version: 5

Template: GitHub
Owner: dscharrer
Project: innoextract
